package com.yuandian.dataflow.controller;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import com.alipay.sofa.jraft.Status;
import com.yuandian.dataflow.projo.Response;
import com.yuandian.dataflow.statemachine.StateServerFactory;
import com.yuandian.dataflow.statemachine.SyncDataClosure;
import com.yuandian.dataflow.statemachine.rpc.TaskState;

import lombok.var;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class TaskLog {

 

	@GetMapping(path = "/test")
	public ResponseEntity<Response> Processing() throws InterruptedException {

		// var state = StateServerFactory.getStateServer().getFsm().getTaskState();
	 
		
		SyncDataClosure closure = new SyncDataClosure() {
			@Override
			public void run(Status status) {
				synchronized(lockObject) {
					lockObject.notify();
				}
			}
	 	};
		var state = new TaskState();
		state.setTaskQueueSize(1);
		closure.setTaskState(state);
		StateServerFactory.getStateServer().readIndexState(true, closure);
	 
		synchronized(closure.lockObject) { 
			closure.lockObject.wait();
		}
			
	 
		
 

		final Response response = new Response();
		response.Code = HttpStatus.OK;
		response.Message = closure.getTaskState().toString();
		return new ResponseEntity<Response>(response, HttpStatus.OK);
	}

	@GetMapping(path = "/test2")
	public ResponseEntity<Response> MongodbTest(@RequestParam int status) {

		Response response = new Response();
		return new ResponseEntity<Response>(response, HttpStatus.OK);
	}
}
